unit DirItReg;

interface

uses
  DirIters, DesignIntf, DesignEditors;

type
  TDirectoryEditor = class(TPropertyEditor)
  public
    function GetValue: string; override;
    procedure SetValue(const Value: string); override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

procedure Register;

implementation

uses Classes, SysUtils, FileCtrl;

procedure Register;
begin
  RegisterComponents('Samples', [TDirectoryIterator]);
  RegisterPropertyEditor(TypeInfo(string), TComponent, 'Directory',
    TDirectoryEditor);
end;


{ TDirectoryEditor }

procedure TDirectoryEditor.Edit;
var
  FilePath: string;
begin
  FilePath := '';
  if SelectDirectory('Select Directory', '', FilePath) then
  begin
    if AnsiLastChar(FilePath)^ = '\' then Delete(FilePath, Length(FilePath), 1);
    SetStrValue(FilePath);
  end;
end;

function TDirectoryEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paMultiSelect];
end;

function TDirectoryEditor.GetValue: string;
begin
  Result := GetStrValue;
end;

procedure TDirectoryEditor.SetValue(const Value: string);
begin
  SetStrValue(Value);
end;



end.
